--- chan_sip.c	2008-12-19 21:03:52.000000000 -0500
+++ chan_sip.c.new	2008-12-19 21:03:37.000000000 -0500
@@ -7285,22 +7285,18 @@
 				ast_debug(3, "FaxMaxDatagram: %d\n", x);
 				ast_udptl_set_far_max_datagram(p->udptl, x);
 				ast_udptl_set_local_max_datagram(p->udptl, x);
-			} else if ((sscanf(a, "T38FaxFillBitRemoval:%d", &x) == 1)) {
+			} else if ((sscanf(a, "T38FaxFillBitRemoval") == 1)) {
 				found = 1;
-				ast_debug(3, "FillBitRemoval: %d\n", x);
-				if (x == 1)
-					peert38capability |= T38FAX_FILL_BIT_REMOVAL;
-			} else if ((sscanf(a, "T38FaxTranscodingMMR:%d", &x) == 1)) {
+				ast_debug(3, "FillBitRemoval\n");
+				peert38capability |= T38FAX_FILL_BIT_REMOVAL;
+			} else if ((sscanf(a, "T38FaxTranscodingMMR") == 1)) {
 				found = 1;
-				ast_debug(3, "Transcoding MMR: %d\n", x);
-				if (x == 1)
-					peert38capability |= T38FAX_TRANSCODING_MMR;
-			}
-			if ((sscanf(a, "T38FaxTranscodingJBIG:%d", &x) == 1)) {
+				ast_debug(3, "Transcoding MMR\n");
+				peert38capability |= T38FAX_TRANSCODING_MMR;
+			} else if ((sscanf(a, "T38FaxTranscodingJBIG") == 1)) {
 				found = 1;
-				ast_debug(3, "Transcoding JBIG: %d\n", x);
-				if (x == 1)
-					peert38capability |= T38FAX_TRANSCODING_JBIG;
+				ast_debug(3, "Transcoding JBIG\n");
+				peert38capability |= T38FAX_TRANSCODING_JBIG;
 			} else if ((sscanf(a, "T38FaxRateManagement:%255s", s) == 1)) {
 				found = 1;
 				ast_debug(3, "RateManagement: %s\n", s);
@@ -8427,9 +8423,13 @@
 		ast_str_append(&a_modem, 0, "a=T38FaxVersion:1\r\n");
 	if ((x = t38_get_rate(p->t38.jointcapability)))
 		ast_str_append(&a_modem, 0, "a=T38MaxBitRate:%d\r\n", x);
-	ast_str_append(&a_modem, 0, "a=T38FaxFillBitRemoval:%d\r\n", (p->t38.jointcapability & T38FAX_FILL_BIT_REMOVAL) ? 1 : 0);
-	ast_str_append(&a_modem, 0, "a=T38FaxTranscodingMMR:%d\r\n", (p->t38.jointcapability & T38FAX_TRANSCODING_MMR) ? 1 : 0);
-	ast_str_append(&a_modem, 0, "a=T38FaxTranscodingJBIG:%d\r\n", (p->t38.jointcapability & T38FAX_TRANSCODING_JBIG) ? 1 : 0);
+	if ((p->t38.jointcapability & T38FAX_FILL_BIT_REMOVAL) == T38FAX_FILL_BIT_REMOVAL)
+		ast_str_append(&a_modem, 0, "a=T38FaxFillBitRemoval\r\n");
+	if ((p->t38.jointcapability & T38FAX_TRANSCODING_MMR) == T38FAX_TRANSCODING_MMR)
+		ast_str_append(&a_modem, 0, "a=T38FaxTranscodingMMR\r\n");
+	if ((p->t38.jointcapability & T38FAX_TRANSCODING_JBIG) == T38FAX_TRANSCODING_JBIG)
+		ast_str_append(&a_modem, 0, "a=T38FaxTranscodingJBIG\r\n");
+
 	ast_str_append(&a_modem, 0, "a=T38FaxRateManagement:%s\r\n", (p->t38.jointcapability & T38FAX_RATE_MANAGEMENT_LOCAL_TCF) ? "localTCF" : "transferredTCF");
 	x = ast_udptl_get_local_max_datagram(p->udptl);
 	ast_str_append(&a_modem, 0, "a=T38FaxMaxBuffer:%d\r\n", x);
